%bcond_with testsuite

Summary:	Build an optimized subroutine parameter validator once, use it forever
Name:		perl-Params-ValidationCompiler
Version:	0.31
Release:	2%{?dist}
License:	Artistic 2.0
URL:		https://metacpan.org/release/Params-ValidationCompiler
Source0:	https://cpan.metacpan.org/modules/by-module/Params/Params-ValidationCompiler-%{version}.tar.gz
# Build
BuildRequires:	coreutils make
BuildRequires:	perl-generators perl-interpreter perl(ExtUtils::MakeMaker) > 6.75
# Module
BuildRequires:	perl(B) perl(Carp) perl(Class::XSAccessor) perl(Eval::Closure)
BuildRequires:	perl(Exception::Class) perl(Exporter)
BuildRequires:	perl(overload) perl(Scalar::Util) perl(strict) perl(warnings)
BuildRequires:	perl(List::Util) >= 1.29
BuildRequires:	perl(Sub::Util) >= 1.40
# Tests
%if %{with testsuite}
BuildRequires:	perl(File::Spec) perl(Specio::Declare) perl(Specio::Library::Builtins)
BuildRequires:	perl(Test::Without::Module) perl(Test2::Plugin::NoWarnings) perl(Test2::Require::Module) perl(Test2::V0)
BuildRequires:	perl(Specio) >= 0.14
BuildRequires:	perl(Test::More) >= 1.302015
%endif

BuildArch:	noarch

Recommends:	perl(Class::XSAccessor) perl(Sub::Util) >= 1.40

%description
This module creates a customized, highly efficient parameter checking subroutine.
It can handle named or positional parameters, and can return the parameters as key/value pairs or a list of values.
In addition to type checks, it also supports parameter defaults, optional parameters, and extra "slurpy" parameters.


%prep
%autosetup -n Params-ValidationCompiler-%{version}


%build
perl Makefile.PL INSTALLDIRS=vendor NO_PERLLOCAL=1 NO_PACKLIST=1
%make_build


%install
%make_install
%{_fixperms} -c %{buildroot}


%check
%if %{with testsuite}
make test
%endif

%files
%license LICENSE
%doc Changes CODE_OF_CONDUCT.md CONTRIBUTING.md eg/ README.md
%{perl_vendorlib}/Params/
%{_mandir}/man3/Params::ValidationCompiler.3*
%{_mandir}/man3/Params::ValidationCompiler::Compiler.3*
%{_mandir}/man3/Params::ValidationCompiler::Exceptions.3*


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.31-2
- Rebuilt for loongarch release

* Wed Dec 20 2023 Upgrade Robot <upbot@opencloudos.org> - 0.31-1
- Upgrade to version 0.31

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.30-6
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 Xiaojie Chen <jackxjchen@tencent.com> - 0.30-5
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.30-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.30-3
- Rebuilt for OpenCloudOS Stream 23

* Thu Feb 16 2023 Shuo Wang <abushwang@tencent.com> - 0.30-2
- remove unused buildrequires

* Tue Aug 16 2022 rockerzhu <rockerzhu@tencent.com> - 0.30-1
- Initial build
